<?php
/*!! Structure.Kernel.XcBase:
*  ,   . XcBase        .
*     .
*/
class XcBase
{
   var $_basepath;
   var $_parent;
   var $_localname = '';
   var $_db;
   var $_access;
   var $_users;

   var $ext_services = '';
   var $services_cache = array();

/*!! Structure.Kernel.XcBase.XcBase:
* ##function XcBase($parent)##
* .    ,  ,   .
*/
 function XcBase($parent)
 {
   $this->debugPrint('Constructor: ('.$parent->_localname.')');
   $this->_parent = $parent;
   $this->_basepath = $this->srvFilePath();
   $this->debugPrint('BasePath: ('.$this->_localname.') '.$this->_basepath);
   if(file_exists($this->_basepath.'/config.php')) {
      include($this->_basepath.'/config.php');
      $this->config = $config;
   }
 }

/*!! Structure.Kernel.XcBase.srvInitKernelServices, Function.Extension:
* ##function srvInitKernelServices ()##
*    : **DB, Users  Access**.   .
*            .
*/

 function srvInitKernelServices () {
      $kernel = $this->srvMainKernel();
      $this->_db = $kernel->srvFactoryNoAccess('DB');
      $this->_users = $kernel->srvFactoryNoAccess('Users');
      $this->_access = $kernel->srvFactoryNoAccess('Access');
 }

/*!! Structure.Kernel.XcBase.srvFilePath, Function.Extension:
* ##function srvFilePath()##
*      .
*/

 function srvFilePath() {
   $this->debugPrint('srvFilePath: '.$this->_localname);
   if($this->_parent!=null) {
     return $this->_parent->srvFilePath().'/extensions/'.$this->_localname;
   } else {
     return realpath(dirname(__FILE__));
   }


 }

/*!! Structure.Kernel.XcBase.srvAbsolutePath, Function.Extension:
* ##function srvAbsolutePath()##
*     . :   SpawHtml   ,  **Kernel/SpawHtml**.
*/

 function srvAbsolutePath() {
   if($this->_parent) {
     return $this->_parent->srvAbsolutePath().'/'.$this->_localname;
   }
   return $this->_localname;
 }


/*!! Structure.Kernel.XcBase.srvMainKernel, Function.Extension:
*     () .   ,    .
*/

 function srvMainKernel() {
   $this->debugPrint('srvMainKernel: '.$_localname);
   if($this->_parent!=null) {
     return $this->_parent->srvMainKernel();
   } else {
     return $this;
   }
 }

/*!! Structure.Kernel.XcBase.xcbGetConfigValue, Function.Config:
* ##function GetConfigValue($name)##
*  ,   .
* @param $name  
*/
 function GetConfigValue($name) { return isset( $this->config[$name] ) ? $this->config[$name] : ''; }

//--------------------------------- Services -------------------------------

/*!! Structure.Kernel.XcBase.xcbsrvLoadAll, Function.Extension:
* ##function srvLoadAll()##
*         .    ,   
*      .
*             .
*/

  function srvLoadAll() {
    if ($this->ext_services=="") $this->ext_services=$this->_db->LoadAll("SELECT * FROM ".$this->_db->config["table_prefix"]."services WHERE parent='".quote($this->srvAbsolutePath())."'");
    //$this->debugPrint("SELECT * FROM ".$this->_db->config["table_prefix"]."services WHERE parent='".quote($this->srvAbsolutePath())."'");
    //$this->debugPrint($this->ext_services);
    return $this->ext_services;
  }


/**
*  ,    .        
*     .
* @param $name  
* @return boolean   DB,     ; false   .
*/

  function srvIsInstalled($name) {
    $res = $this->srvLoadAll();
    if($res!="") {
      foreach($res as $serv) {
        if($serv["name"]==$name) return $serv;
      }
    }
    return false;
  }

/*!! Structure.Kernel.XcBase.srvFactory, Function.Extension:
*     -,  ,   .
*/


   function srvFactory($servname) {
     if($srvDb = $this->srvIsInstalled($servname)) {
        return $this->srvFactoryNoAccess($servname);
     } else {
        return null;
     }
   }

/*!! Structure.Kernel.XcBase.srvFactoryNoAccess, Function.Extension:
*   -   .
*            ,   . .., ** -  Singleton**.
*/

   // new services

   function srvFactoryNoAccess($servname) {

       $this->debugPrint('srvFactoryNoAccess: '.$this->_localname.' serv '.$servname);
       $res = $this->service_cache[$servname];
       if ($res) {
          $this->debugPrint('srvFactoryNoAccess: '.$this->_localname.' USE CACHE serv '.$servname);
          return $res;
       } else {
         if (file_exists($this->_basepath.'/extensions/' . $servname . '/'.$servname.'.php')) {
         if (require_once($this->_basepath.'/extensions/' . $servname . '/'.$servname.'.php')) {
             $classname = 'Service_'.$servname;
             $serv = &new $classname($this);
             $this->service_cache[$servname] = &$serv;
             $serv->srvInitKernelServices();
             return $serv;
          } else {
             //throw new Exception ('Service '.$servname.' class not found');
             $this->debugPrint('Service '.$servname.' class not found');
             return null;
         }
         } else {
             return null;
         }
       }

   }

/*!! Structure.Kernel.XcBase.srvRunAll:
* ##function srvRunAll($serviceFunction, $params)##
*    $serviceFunction  !      :
* Array ([ ] => [  ]);
* @param string   
* @param array   .
* @link Structure.Kernel.XcBase, Function.Extension:
* !!   $serviceFunction  !      .!!
*/

    function srvRunAll($serviceFunction, $params) {
      $cached = $this->_db->LoadSingle("SELECT SQL_NO_CACHE * FROM ".$this->_db->config["table_prefix"]."eventcachecheck WHERE eventname='".quote($serviceFunction)."'");
      if($cached == "") {
         $this->srvRunAllMakeCache($serviceFunction, $params);
      }
      $result = array();
      $servs = $this->_db->LoadAll("SELECT * FROM ".$this->_db->config["table_prefix"]."eventcache WHERE eventname='".quote($serviceFunction)."'");
      if ($servs!=array()) {
         foreach($servs as $srv) {
             $sr = $this->srvFactory($srv["name"]);
             if ($sr) {
               $resone = $this->srvRunOne($sr,$serviceFunction,$params);
               if($resone !== null) {
                 $result[$srv["name"]] = $resone;
               }
             }
         }
      }
      return $result;
   }

   function srvRunAllMakeCache($serviceFunction, $params) {
      $servs = $this->srvLoadAll();
      if ($servs!=array()) {
         foreach($servs as $srv) {
             $sr = $this->srvFactory($srv["name"]);
             if ($sr) {
               $resone = $this->srvRunOneFake($sr,$serviceFunction,$params);
               if($resone) {
                 $this->_db->insertInto("eventcache", array("eventname" => $serviceFunction, "name" => $srv["name"]));
               }
             }
         }
      }
      $this->_db->insertInto("eventcachecheck", array("eventname" => $serviceFunction));
   }

/*!! Structure.Kernel.XcBase.srvRunOne, Function.Extension:
* ##function srvRunOne($serviceObject,$serviceFunction, $params)##
*        . ,     : ##srvRunOne($serviceSpawHtml, "onInstall", '');##
*/

   function srvRunOne($serviceObject,$serviceFunction, $params) {
       if(method_exists($serviceObject, $serviceFunction)) {
         return call_user_method($serviceFunction, $serviceObject, $params);
       } else {
         return null;
       }
   }

   function srvRunOneFake($serviceObject,$serviceFunction, $params) {
       if(method_exists($serviceObject, $serviceFunction)) {
         return true;
       } else {
         return false;
       }
   }

/*!! Structure.Kernel.XcBase.debugPrint:
* ##function debugPrint($txt)##
*     .    -  .
*/

   function debugPrint($txt) {
   /*
     $fd = fopen('debug.txt','a');
     fwrite($fd,'('.$this->_localname.'): '.$txt."\n");
     fclose($fd);
   */
   }

/*!! Structure.Kernel.XcBase.onInstall, Function.Extension:
* ##function onInstall($params)##
* ,    .    TRUE,  ,     .
*        ,    .
*/

   function onInstall($params) {
     return true;
   }

/*!! Structure.Kernel.XcBase.onUninstall, Function.Extension:
* ##function onUninstall($params)##
* ,    .    TRUE,  ,     .
*        ,    .
*/
   function onUninstall($params) {
     return true;
   }

/*!! Structure.Kernel.XcBase.srvInstallService, Function.Extension:
* ##function srvInstallService($serviceName, $params)##
* ,   .     TRUE.
*/

   function srvInstallService($serviceName, $params) {
     if($this->srvIsInstalled($serviceName)) {
        return false;
     } else {
        $srvObject = $this->srvFactoryNoAccess($serviceName);
        if($this->srvRunOne($srvObject, 'onInstall', $params)) {
           $this->_db->Query('INSERT INTO '.$this->_db->config["table_prefix"]."services SET name='".quote($serviceName)."'");
           return true;
        } else {
           return false;
        }
     }
   }

/*!! Structure.Kernel.XcBase.srvUninstallService, Function.Extension:
* ##function srvUninstallService($serviceName, $params)##
* ,   .     TRUE.
*/

   function srvUninstallService($serviceName, $params) {
     if(!$this->srvIsInstalled($serviceName)) {
        return false;
     } else {
        $srvObject = $this->srvFactoryNoAccess($serviceName);
        $this->srvRunOne($srvObject, 'onUninstall', $params);
        $this->_db->Query("DELETE FROM ".$this->_db->config["table_prefix"]."services WHERE name='".quote($serviceName)."'");
        return true;
     }
   }

}

?>
